<?php

/**
 * NP_MobileWithSinglePage 2.1.0
 * Ѥ˥ڡƤѹ
 */

 /*
  * Copyright (C) 2006-2007 NKJG
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  * 
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
  * 
  * In addition, as a special exception, NKJG gives
  * permission to link the code of this program with those files in the PEAR
  * library that are licensed under the PHP License (or with modified versions
  * of those files that use the same license as those files), and distribute
  * linked combinations including the two. You must obey the GNU General Public
  * License in all respects for all of the code used other than those files in
  * the PEAR library that are licensed under the PHP License. If you modify
  * this file, you may extend this exception to your version of the file,
  * but you are not obligated to do so. If you do not wish to do so, delete
  * this exception statement from your version.
 */

require_once (dirname(__FILE__).'/sharedlibs/sharedlibs.php');
require_once ('nkjg/pluginextra.php'); // ץ饰ζʬ
require_once ('nkjg/pluginoptioncreator.php'); // ץ

define('PLUG_MOBILEWITHSINGLEPAGE_SKIN_DELIM', '/');
define('PLUG_MOBILEWITHSINGLEPAGE_SKIN_DEFAULTNAME', 'mobile');


class NP_MobileWithSinglePage extends SHAREDLIBS_NKJG_PLUGINEXTRA {
  var $isStarted = false; // Хåե󥰾
  var $aSkinName = false; // Υꥹ
  var $toEncodeComment = false; // Ȥ򥨥󥳡ɤ
  var $isMobile = false;
  var $aMobileInfo = null;

  var $skinName;
  var $toSJIS;
  var $enableMobileProxy;
  var $mobileProxy;
  var $noMobileProxy;
  var $baseURL;
  var $mode;
  var $conversion;

  function getName() { return PLUG_MOBILEWITHSINGLEPAGE_TEXT_PLUGINNAME; }
  function getAuthor() { return 'NKJG + akebia'; }
  function getVersion() { return '2.1.0-1 beta'; }
  function getURL() { return 'http://nyan.co.uk/akebia/item/175'; }
  function getDescription(){ return PLUG_MOBILEWITHSINGLEPAGE_TEXT_DESCRIPTION; }
  
  function getEventList() {
    return array(
      'PostAuthentication',
      'PreSendContentType',
      'InitSkinParse',
      'PreSkinParse',
      'PostSkinParse',
      'FormExtra',
      'ValidateForm',
      'PreAddComment',
      );
  }

  function init() {
    $this->aMobileInfo = array();
    $this->incLangFile();
  }

  //////// 󥹥ȡ롦ץ ////////
  function install() {
    $objOptionCreator =& new SHAREDLIBS_NKJG_PLUGINOPTIONCREATOR(&$this);
    $objOptionCreator->createGlobalOption_YesNo('changeSkin', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_CHANGESKIN, 'yes'); // since 2.1.0
    $objOptionCreator->createGlobalOption_Text('skinName', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_SKINNAME);
    
    $objOptionCreator->createGlobalOption_YesNo('conversion', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_CONVERSION, 'yes'); // since 2.1.0
    $objOptionCreator->createGlobalOption_Select(
      'imgOperate',
      PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_IMGOPERATE,
      array(
        PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_IMGOPERATE_TOTEXT => 'text',
        PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_IMGOPERATE_TOLINK => 'link',
        PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_IMGOPERATE_NO_CONVERT => 'no',
        )
      );
    $objOptionCreator->createGlobalOption_YesNo('removeQuot', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_REMOVEQUOT, 'yes');
    $objOptionCreator->createGlobalOption_YesNo('useHankaku', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_USEHANKAKU, 'yes');
    $objOptionCreator->createGlobalOption_TextArea('tagsNotRemove', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_TAGSNOTREMOVE, 'html|head|meta|link|title|body|h1|h2|h3|h4|h5|h6|form|input|label|textarea|ul|ol|li|br|hr|p|div|table|tr|td|th|img|a|dl|dt|dd');
    $objOptionCreator->createGlobalOption_TextArea('attributesNotRemove', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_ATTRSNOTREMOVE, 'media|rel|id|src|name|href|alt|action|method|enctype|accept|accpept-charset|value|type|for|title|http-equiv|content|scheme|accesskey');
    $objOptionCreator->createGlobalOption_YesNo('enableMobileProxy', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_ENABLEMOBILEPROXY, 'yes');
    $objOptionCreator->createGlobalOption_TextArea('mobileProxy', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_MOBILEPROXY, 'http://www.google.co.jp/gwt/n?u=<%url%>');
    $objOptionCreator->createGlobalOption_TextArea('noMobileProxy', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_NOMOBILEPROXY, '^http://www\.google\.co\.jp/gwt/n$|^http://www\.google\.co\.jp/gwt/n\?');
    $objOptionCreator->createGlobalOption_YesNo('toSJIS', PLUG_MOBILEWITHSINGLEPAGE_TEXT_OPTION_TOSJIS, 'no');
  }

  function event_PostAuthentication($data) {
    global $CONF;
    if($CONF['UsingAdminArea']){return;}
    $this->skinName = $this->getOption('skinName');
    if(isset($_GET[$this->skinName])){
      $this->mode = getVar($this->skinName);
      if(!$this->mode){return;}
    }else{
      $this->mode = 0;
    }
    $userAgent = serverVar('HTTP_USER_AGENT');
    require_once('Net/UserAgent/Mobile.php');
    $objUAMobile =& Net_UserAgent_Mobile::factory($userAgent);
    if(($objUAMobile->isNonMobile() || $objUAMobile->isError()) && !$this->mode){return;}
    $this->isMobile = true;

    if(!$this->mode){$this->mode = 1;}
    $this->aMobileInfo['mode'] = $this->mode;
    $this->aMobileInfo['skinName'] = $this->skinName;
    $this->conversion = $this->getOption('conversion') != 'no' ? 1 : 0;
    $this->toSJIS = $this->getOption('toSJIS') != 'no' ? 1 : 0;
    $this->aMobileInfo['toSJIS'] = $this->toSJIS;
    if($this->mode > 1){
      $this->enableMobileProxy = 0;
    }else{
      $this->enableMobileProxy = $this->getOption('enableMobileProxy') != 'no' ? 1 : 0;
    }
    if($this->enableMobileProxy){
      $this->aMobileInfo['enableMobileProxy'] = 1;
      $this->mobileProxy = $this->getOption('mobileProxy');
      $this->noMobileProxy = $this->getOption('noMobileProxy');
      $this->baseURL = $this->getBaseURL();
      $this->aMobileInfo['baseURL'] = $this->baseURL;
    }

    $this->aMobileInfo['carrierLongName'] = $objUAMobile->getCarrierLongName();
    $this->aMobileInfo['carrierShortName'] = $objUAMobile->getCarrierShortName();
    $this->aMobileInfo['name'] = $objUAMobile->getName();
    $this->aMobileInfo['version'] = $objUAMobile->getVersion();
    $objDisplay = $objUAMobile->getDisplay();
    if(PEAR::isError($objDisplay)){return;}
    $this->aMobileInfo['height'] = $objDisplay->getHeight();
    $this->aMobileInfo['width'] = $objDisplay->getWidth();
    $this->aMobileInfo['color'] = $objDisplay->isColor();
    $this->aMobileInfo['depth'] = $objDisplay->getDepth();
  }

  function event_InitSkinParse($data) {
    if ($this->isMobile && $this->getOption('changeSkin') != 'no') {
      $this->changeSkin(&$data['skin']);
    }
  }
  
  // ѹ
  function changeSkin(&$skin) {
    $currentSkinName = $skin->getName();
    $newSkinName = $this->_getNewSkinName($currentSkinName);
    if ($newSkinName != $currentSkinName) {
      $newSkin =& SKIN::createFromName($newSkinName);
      // copied from NP_SkinSwitcher.php
      $skin->SKIN($newSkin->getID()); 
    }
  }
  
  // ѹ륹̾η
  function _getNewSkinName($baseName) {
    $result = $baseName;
    $carrierName = trim(strtolower($this->aMobileInfo['carrierLongName']));
    $optionName = $this->skinName;
    $delim = PLUG_MOBILEWITHSINGLEPAGE_SKIN_DELIM;

    $aSkinName = array();
    if ($optionName) {
      $aSkinName[] = ($optionName . $delim . $carrierName);
      $aSkinName[] = ($optionName);
    }
    $aSkinName[] = ($baseName . $delim . $carrierName);
    $aSkinName[] = ($baseName . $delim . PLUG_MOBILEWITHSINGLEPAGE_SKIN_DEFAULTNAME);
    
    $aSkinList = $this->_getSkinList();

    foreach ($aSkinName as $skinName) {
      if (in_array($skinName, $aSkinList)) {
        $result = $skinName;
        break;
      }
    }

    return $result;
  }
  
  function event_PreSendContentType($data) {
    if ($this->isMobile && $this->toSJIS) {
      $data['charset'] = 'Shift_JIS';
      $data['contentType'] = 'text/html';
    }
  }

  function event_PreSkinParse($data) {
    if ($this->isMobile) {
      // åϤʤ
      header('Pragma: no-cache');
      header('Cache-Control: no-cache, must-revalidate');

      if ($this->conversion || $this->toSJIS) {
        ob_implicit_flush(false);
        $this->isStarted = ob_start(array(&$this, 'doConvert'));
      }
    }
  }

  function event_PostSkinParse($data) {
    if ($this->isStarted) {
      ob_end_flush();
    }
  }

  function doConvert($strHTML) {
    if ($this->conversion) {
      $strHTML = $this->doConvert_HTML($strHTML);
    }
    if ($this->getOption('useHankaku') != 'no') {
      $strHTML = $this->doConvert_hankaku($strHTML);
    }
    if ($this->toSJIS) {
      $strHTML = $this->doConvert_encoding($strHTML);
    }

    return $strHTML;
  }

  function doConvert_HTML($strHTML) {
    $aTagNotRemove = explode('|', strtolower($this->getOption('tagsNotRemove')));
    $aAttrNotRemove = explode('|', strtolower($this->getOption('attributesNotRemove')));
    $removeQuot = ($this->getOption('removeQuot') != no);
    $imgOperate = $this->getOption('imgOperate');

    $handler =& new PLUG_MOBILEWITHSINGLEPAGE_HTMLCONVERTER($aTagNotRemove, $aAttrNotRemove, $removeQuot, $imgOperate, $this);

    require_once('XML/XML_HTMLSax.php');
    $parser =& new XML_HTMLSax();
    $parser->set_option(XML_OPTION_CASE_FOLDING);
    $parser->set_object($handler);
    $parser->set_element_handler('openHandler', 'closeHandler');
    $parser->set_data_handler('dataHandler');

    $parser->parse($strHTML);
    
    $strHTML = $handler->getResult();

    return $strHTML;
  }

  function doConvert_encoding($strHTML) {
    $strHTML = mb_convert_encoding($strHTML, 'SJIS', _CHARSET);

    return $strHTML;
  }

  function doConvert_hankaku($strHTML) {
    $strHTML = mb_convert_kana($strHTML, 'rnask', _CHARSET);

    return $strHTML;
  }

  function event_FormExtra($data) {
    switch ($data['type']) {
    case 'commentform-loggedin' :
    case 'commentform-notloggedin' :
      break;
    default :
      return;
    }
    if(!$this->isMobile){return;}
    if($this->conversion){
      echo ('<input type="hidden" name="'.$this->skinName.'" value="'.$this->mode.'" />');
    }
    if($this->toSJIS){
      echo ('<input type="hidden" name="'.$this->skinName.'_toSJIS" value="'.$this->toSJIS.'" />');
    }
  }

  function event_ValidateForm($data) {
    if(!$data['comment']){return;}
    if(postVar($this->skinName.'_toSJIS')){$this->toEncodeComment = true;}
    $this->mode = postVar($this->skinName);
    if(!$this->mode){return;}
    if(!isset($_POST['url'])){$_POST['url'] = createItemLink($post['itemid']);}
    $this->doConvert_href($_POST['url'], array($this->skinName.'_c' => 1));
  }

  function event_PreAddComment($data) {
    if ($this->toEncodeComment) {
      mb_convert_variables(_CHARSET, "auto", $data['comment']);
    }
  }

  function _getSkinList() {
    if ($this->aSkinName == false) {
      $aSkinName = array();
      
      $query = ('SELECT sdname FROM ' . sql_table('skin_desc'));
      $result = sql_query($query);
      while ($aResult = mysql_fetch_array($result)) {
        array_push($aSkinName, $aResult['sdname']);
      }

      $this->aSkinName = $aSkinName;
    }

    return $this->aSkinName;
  }

  // since 2.1.0
  function doSkinVar($skinType, $name = '') {
    $result = '';
    if (isset($this->aMobileInfo[$name])) {
      if ($this->aMobileInfo[$name] === true) {
        $result = 'yes';
      } elseif ($this->aMobileInfo[$name] === false) {
        $result = 'no';
      } else {
        $result = $this->aMobileInfo[$name];
      }
    }
    echo $result;
  }

  function doIf($key = '', $value = '') {
    $result = false;
    if ($key != '') {
      if(isset($this->aMobileInfo[$key])){
        $w = $this->aMobileInfo[$key];
      }else{
        $w = getVar($this->skinName.'_'.$key);
      }
      if ($value != '') {
        if (is_numeric($value)) {
          $result = (intval($w) <= intval($value));
        } else {
          $result = ($w == $value);
        }
      } else {
        $result = !!($w);
      }
    } else {
      $result = $this->isMobile;
    }
    return $result;
  }

  function getBaseURL(){
    if($_SERVER["SERVER_PORT"] == 80){
      return 'http://'.$_SERVER{'SERVER_NAME'};
    }
      return 'http://'.$_SERVER{'SERVER_NAME'}.':'.$_SERVER["SERVER_PORT"];
  }

  function doConvert_href(&$href, $params = ''){
    global $CONF;
    for(;;){
      $i = strpos($href, '?');
      if($i !== 0){
        if(strpos($href, $CONF['Self']) !== 0){break;}
        if(ereg("[^/?]", substr($href, strlen($CONF['Self']), 1))){break;}
      }
      $j = strpos($href, '#');
      if($j !== false){
        if($j < 1){break;}
        $k = substr($href, $j);
      }else{
        $k = '';
	$j = strlen($href);
      }
      if($i === false){
        $a = ''; $href .= '?';
      }else{
        $a = substr($href, $i + 1, $j - $i - 1);
	$href = substr($href, 0, $i + 1);
      }
      $b = array(); parse_str($a, $b);
      if(!isset($b[$this->skinName])){$b[$this->skinName] = $this->mode;}
      if(is_array($params)){$b += $params;}
      $href .= http_build_query($b).$k;
      return;
    }
   for(;;){
      if(!$this->enableMobileProxy){break;}
      if(strpos($href, '/') === 0){
        $k = $this->baseURL.$href;
      }elseif(strpos($href, '//') !== false){
        $k = $href;
      }else{
        break;
      }
      if(ereg($this->noMobileProxy, $k)){break;}
   	$href = str_replace('<%url%>', rawurlencode($k), $this->mobileProxy);
        break;
    }
      return;
  }
}

// PEAR::XML_HTMLSaxȤäƤߤ (ְ㤤ʤ٤)
class PLUG_MOBILEWITHSINGLEPAGE_HTMLCONVERTER {
  var $aTagNotRemove; // ʤ
  var $aAttrNotRemove; // ʤ°̾
  var $removeQuot; // 뤫ɤ
  var $imgOperate; // IMGǤν
  
  var $isEmpty = false; // bool "ľǤϥǤ"
  var $aNestLevel = 0; // aǤΥͥȥ٥(٥aǤΤߥϤ)
  var $aVoidLevel = 0; // ̵ǤΥͥȥ٥

  var $result = ''; // 

  var $npmwsg;

  // Ƽ索ץΥå
  function PLUG_MOBILEWITHSINGLEPAGE_HTMLCONVERTER ($aTagNotRemove, $aAttrNotRemove, $removeQuot, $imgOperate, &$npmwsg) {
    $this->aTagNotRemove = $aTagNotRemove;
    $this->aAttrNotRemove = $aAttrNotRemove;
    $this->removeQuot = $removeQuot;
    $this->imgOperate = $imgOperate;
 
    $this->npmwsg = $npmwsg;

    // ǤǤ뤳ȤǧƤ (ʸϻ)
    $this->emptyElement = array(
      'br',
      'area',
      'link',
      'img',
      'param',
      'hr',
      'input',
      'col',
      'base',
      'meta',
      );

    // ǤʤƤɽʤ
    $this->voidElement = array(
      'script',
      );
      
  }

  // ϥϥɥ
  function openHandler(&$parser, $tagName, $aAttr) {
    $result = '';
    $tagName = strtolower($tagName);

    $result .= $this->endOfEmpty();
    
    if (in_array($tagName, $this->voidElement)) {
      $this->voidLevel++;
    } else if ($this->voidLevel == 0 && in_array($tagName, $this->aTagNotRemove)) {
      switch ($tagName) {
      case 'img' :
        $result .= $this->openHandler_img($aAttr);
        break;
      case 'a' :
        $result .= $this->openHandler_a($aAttr);
        break;
      default :
        $result .= $this->openHandler_default($tagName, $aAttr);
        break;        
      }
    }

    $this->result .= $result;
  }

  // imgѳϥϥɥ
  function openHandler_img($aAttr) {
    $result = '';

    // إƥ
    $altText = '';
    if (isset($aAttr['alt'])) {
      $altText = $aAttr['alt'];
    }
    
    switch ($this->imgOperate) {
    case 'text' : // ƥȤѴ
      if ($altText !== '') {
        $result .= $altText;
        $this->isEmpty = false;
      }
      break;
      
    case 'link' : // 󥯤Ѵ
      if ($altText === '') {
        $altText = '[image]'; // إƥȤξ'[image]'
      }
      $aNewAttr = $aAttr;
      $aNewAttr['href'] = $aNewAttr['arc']; // src°href°ˤ
      unset($aNewAttr['arc']);
      unset($aNewAttr['alt']);

      $result .= $this->openHandler_a($aNewAttr); // a(ϥ)
      $result .= $altText;
      $this->isEmpty = false;
      break;

    default : // Τޤ޲ǽϤ
      $result .= $this->openHandler_default('img', $aAttr);
    }

    return $result;
  }

  // aѳϥϥɥ
  function openHandler_a($aAttr) {
    // ˤޤaǤʤΤaǤ
    $this->aNestLevel++;
    if ($this->aNestLevel > 1) {return '';}
    if(isset($aAttr['href'])){$this->npmwsg->doConvert_href($aAttr['href']);}
    return $this->openHandler_default('a', $aAttr);
  }

  // ̾γϥϥɥ
  function openHandler_default($tagName, $aAttr) {
    $result = '';
    $tagName = strtolower($tagName);
    $close = '';
    if (in_array($tagName, $this->emptyElement)) {
      $this->isEmpty = true;
    } else {
      $this->isEmpty = false;
    }
    
    $result .= ('<' . $tagName);
    
    foreach ($aAttr as $attrName => $attrValue) {
      $attrName = strtolower($attrName);
      if (in_array($attrName, $this->aAttrNotRemove)) {
        $quot = '"';
        $close = '';
        if ($this->removeQuot && $attrValue != '' && strpos($attrValue, ' ') === FALSE) {
          // ⡼ɤǡʤƤʸǤʤơޤޤʤȤ˰
          $quot = '';
          if (!$this->isEmpty) {
            $close = ' '; // ֤ǥϥۥ磻ȥڡ
          }
        }
        $result .= (' ' . $attrName . '=' . $quot . trim($attrValue) . $quot);
        
      }
    }
    
    if (!$this->isEmpty) {
      $close .= '>';
    }

    $result .= $close;
    
    return $result;
  }

  // λϥɥ
  function closeHandler(&$parser, $tagName) {
    $result = '';
    $tagName = strtolower($tagName);
    if (in_array($tagName, $this->voidElement)) {
      $this->voidLevel--;
    } else if ($this->voidLevel == 0 && in_array($tagName, $this->aTagNotRemove)) {
      switch ($tagName) {
      case 'img' :
        $result .= $this->closeHandler_img();
        break;
      case 'a' :
        $result .= $this->closeHandler_a();
        break;
      default :
        $result .= $this->closeHandler_default($tagName);
        break;        
      }
    }

    $this->result .= $result;
  }
  
  // imgѽλϥɥ
  function closeHandler_img() {
    $result = '';
    
    switch ($this->imgOperate) {
    case 'text' : // ƥȤѴ
      break;
      
    case 'link' : // 󥯤Ѵ
      $result .= $this->closeHandler_a(); // a(λ)
      break;

    default : // Τޤ޲ǽϤ
      $result .= $this->closeHandler_default('img');
    }

    return $result;
  }

  // aѽλϥɥ
  function closeHandler_a() {
    $result = '';

    $this->aNestLevel--;
    
    if ($this->aNestLevel == 0) {
      $result .= $this->closeHandler_default('a');
    }

    return $result;
  }

  // ̾νλϥɥ
  function closeHandler_default($tagName) {
    $result = '';
    $tagName = strtolower($tagName);
    if ($this->isEmpty) {
      $result .= (' />');
    } else {
      $result .= ('</' . $tagName . '>');
    }

    $this->isEmpty = false;

    return $result;
  }

  // ǡΥϥɥ
  function dataHandler(&$parser, $data) {
    $result = '';
    
    $result .= $this->endOfEmpty();

    if ($this->voidLevel == 0) {
      $result .= $data;
    }

    $this->result .= $result;
  }

  function endOfEmpty() {
    $result = '';
    
    if ($this->isEmpty) {
      $result .= ('>'); // 襤('>')
    }

    $this->isEmpty = false;
    
    return $result;
  }
  
  function getResult() {
    // 
    $strHTML = $this->result;
    $strHTML = preg_replace("!(\r|\n|\n\r)!", "\n", $strHTML);
    $strHTML = preg_replace("!\n\s+!", "\n", $strHTML);
    $strHTML = preg_replace("!\s+\n!", "\n", $strHTML);
    $strHTML = preg_replace("!\n+!", "\n", $strHTML);
    $strHTML = preg_replace("!^\n!", "", $strHTML);

    return $strHTML;
  }
}

?>
